

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 clrLime
#property indicator_color2 clrRed

extern int iPeriod = 15;
extern int iFullPeriods = 1;
double Forex01[];
double Forex02[];
bool ForexStation;
int AnInteger;
int Forex03[30];

bool CheckTimeFrame(int TempNumber01, int CurrentTimeFrame01) {
   bool RightTimeFrame = FALSE;
   switch (TempNumber01) {
   case 1:
      RightTimeFrame = TimeMinute(Time[CurrentTimeFrame01]) == 0;
   case 5:
      RightTimeFrame = TimeMinute(Time[CurrentTimeFrame01]) == 0;
      break;
   case 15:
      RightTimeFrame = TimeMinute(Time[CurrentTimeFrame01]) == 0;
      break;
   case 30:
      RightTimeFrame = TimeMinute(Time[CurrentTimeFrame01]) == 0 && MathMod(TimeHour(Time[CurrentTimeFrame01]), 4.0) == 0.0;
      break;
   case 60:
      RightTimeFrame = TimeMinute(Time[CurrentTimeFrame01]) == 0 && MathMod(TimeHour(Time[CurrentTimeFrame01]), 4.0) == 0.0;
      break;
   case 240:
      RightTimeFrame = TimeMinute(Time[CurrentTimeFrame01]) == 0 && TimeHour(Time[CurrentTimeFrame01]) == 0;
      break;
   case 1440:
      RightTimeFrame = TimeDayOfWeek(Time[CurrentTimeFrame01]) == 1 && TimeHour(Time[CurrentTimeFrame01]) == 0;
      break;
   case 10080:
      RightTimeFrame = TimeDay(Time[CurrentTimeFrame01]) == 1 || (TimeDay(Time[CurrentTimeFrame01]) == 2 && TimeDay(Time[CurrentTimeFrame01 + 1]) != 1) || (TimeDay(Time[CurrentTimeFrame01]) == 3 && TimeDay(Time[CurrentTimeFrame01 + 1]) != 2);
      break;
   default:
      Print("!!!!!!!!!!!!!!");
   }
   return (RightTimeFrame);
}

double AverageHigh(int TempNumber01) {
   double TempNumber02;
   double TempNumber03 = 0.0;
   int TempNumber04 = TempNumber01;
   ForexStation = FALSE;
   for (AnInteger = 0; AnInteger < iPeriod + iFullPeriods; AnInteger++) {
      while (!CheckTimeFrame(Period(), TempNumber04)) TempNumber04++;
      if (ForexStation == FALSE) ForexStation = TempNumber04;
      Forex03[AnInteger] = TempNumber04;
      TempNumber04++;
   }
   TempNumber04--;
   for (TempNumber04 = iPeriod - 1; TempNumber04 > 0; TempNumber04--) {
      TempNumber02 = High[iHighest(NULL, 0, MODE_HIGH, Forex03[TempNumber04] - (Forex03[TempNumber04 - 1]), Forex03[TempNumber04 - 1] + 1)];
      TempNumber03 += TempNumber02;
   }
   if (iFullPeriods == 1) {
      TempNumber02 = High[iHighest(NULL, 0, MODE_HIGH, Forex03[iPeriod] - (Forex03[iPeriod - 1]), Forex03[iPeriod - 1] + 1)];
      TempNumber03 += TempNumber02;
      TempNumber03 /= NormalizeDouble(iPeriod, 0);
   } else {
      TempNumber02 = High[iHighest(NULL, 0, MODE_HIGH, Forex03[0] - TempNumber01, TempNumber01)];
      TempNumber03 += TempNumber02;
      TempNumber03 /= NormalizeDouble(iPeriod, 0);
   }
   return (TempNumber03);
}

double AverageLow(int TempNumber01) {
   double TempNumber05;
   double TempNumber03 = 0.0;
   int TempNumber04 = TempNumber01;
   ForexStation = FALSE;
   for (AnInteger = 0; AnInteger < iPeriod + iFullPeriods; AnInteger++) {
      while (!CheckTimeFrame(Period(), TempNumber04)) TempNumber04++;
      if (ForexStation == FALSE) ForexStation = TempNumber04;
      Forex03[AnInteger] = TempNumber04;
      TempNumber04++;
   }
   TempNumber04--;
   for (TempNumber04 = iPeriod - 1; TempNumber04 > 0; TempNumber04--) {
      TempNumber05 = Low[iLowest(NULL, 0, MODE_LOW, Forex03[TempNumber04] - (Forex03[TempNumber04 - 1]), Forex03[TempNumber04 - 1] + 1)];
      TempNumber03 += TempNumber05;
   }
   if (iFullPeriods == 1) {
      TempNumber05 = Low[iLowest(NULL, 0, MODE_LOW, Forex03[iPeriod] - (Forex03[iPeriod - 1]), Forex03[iPeriod - 1] + 1)];
      TempNumber03 += TempNumber05;
      TempNumber03 /= NormalizeDouble(iPeriod, 0);
   } else {
      TempNumber05 = Low[iLowest(NULL, 0, MODE_LOW, Forex03[0] - TempNumber01, TempNumber01)];
      TempNumber03 += TempNumber05;
      TempNumber03 /= NormalizeDouble(iPeriod, 0);
   }
   return (TempNumber03);
}

int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, Forex01);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, Forex02);
   SetIndexEmptyValue(1, 0.0);
   if (iFullPeriods != 0) iFullPeriods = 1;
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int America01;
   int America02;
   int TotalIndi01 = IndicatorCounted();
   if (Period() != PERIOD_W1) {
      if (TotalIndi01 < 0) return (-1);
      if (TotalIndi01 > 0) America02 = Bars - TotalIndi01;
      if (TotalIndi01 == 0) {
         America01 = Bars - 1;
         while (!CheckTimeFrame(Period(), America01)) America01--;
         ForexStation = America01;
         America01--;
         for (AnInteger = 0; AnInteger < iPeriod; AnInteger++) {
            while (!CheckTimeFrame(Period(), America01)) America01--;
            America01--;
         }
         America01++;
         America02 = America01;
      }
      for (int counter01 = America02; counter01 >= 0; counter01--) {
         if (Close[counter01] > AverageHigh(counter01)) {
            Forex01[counter01] = AverageLow(counter01);
            Forex02[counter01] = 0.0;
         } else {
            if (Close[counter01] < AverageLow(counter01)) {
               Forex02[counter01] = AverageHigh(counter01);
               Forex01[counter01] = 0.0;
            } else {
               if (Forex02[counter01 + 1] != 0.0) Forex02[counter01] = AverageHigh(counter01);
               if (Forex01[counter01 + 1] != 0.0) Forex01[counter01] = AverageLow(counter01);
            }
         }
      }
      return (0);
   }
   return (0);
}